//
// :			  -   
// :		Microsoft Visual C++ v6.0
// :		1801BM1@gmail.com
//
//
// 20  2002
//		       
//
#include "vnet32.h"

extern DWORD nline;

//
//      
//     NULL   
//       
//
PFHANDLE FL_Open(char* Name, DWORD BufSize)
{
	PFHANDLE File;
	int Handle, FileSize;

    if (NULL == Name) 
    {
        return NULL;
    }

	Handle = open(Name, _O_RDONLY | _O_SEQUENTIAL | _O_BINARY, 0);
	if (Handle < 0)
	{
		//
		//  
		//
		return NULL;
	}
	if (BufSize == 0)
	{
		FileSize = lseek(Handle, 0, SEEK_END);
		if (FileSize < 0)
		{
			close(Handle);
			return NULL;
		}
		if (lseek(Handle, 0, SEEK_SET) < 0)
		{
			close(Handle);
			return NULL;
		}
		//
		//    
		//
		File = malloc(sizeof(FHANDLE) + FileSize);
		if (NULL == File)
		{
			close(Handle);
			return NULL;
		}
		//
		//    
		//
		File->Handle = Handle; 
		File->Size   = FileSize;
		File->Ptr    = File->End = &File->Data[0];
		File->Flags  = 0;
		File->End   += read(File->Handle, File->Ptr, FileSize);
		close(File->Handle);
		File->Handle = 0;
		return File;
	}
	else
	{
		//
		//    
		//
		File = malloc(sizeof(FHANDLE) + BufSize);
		if (NULL == File)
		{
			close(Handle);
			return NULL;
		}
		File->Handle = Handle; 
		File->Size   = BufSize;
		File->Ptr    = File->End = &File->Data[0];
		File->Flags  = 0;
		return File;
	}
}

//
//      
//     NULL   
//       
//
PFHANDLE FL_Create(char* Name, DWORD BufSize)
{
	PFHANDLE File;

    if (NULL == Name) 
    {
        return NULL;
    }

	//
	//     
	//
	File = malloc(sizeof(FHANDLE) + BufSize);
	if (NULL == File)
	{
		return NULL;
	}

	File->Handle = open(Name,
					_O_CREAT | _O_BINARY | _O_WRONLY | _O_SEQUENTIAL | _O_TRUNC,
					_S_IREAD | _S_IWRITE );

	if (File->Handle < 0)
	{
		//
		//   ,    
		//
		free(File);
		return NULL;
	}

	File->Size = BufSize;
	File->Ptr = &File->Data[0];
	File->End = &File->Data[BufSize];
	File->Flags = FLFLG_ForWrite;
	return File;
}

//
//         
// FL_LINSIZE    .  CR/LF
// 
// 
//  < 0 -       
//			  >=0 -       
//
int FL_ReadLine(PFHANDLE File, PBYTE Data)
{
	BYTE sym;
	int  len;

	len = 0;
	do
	{
		if (File->Ptr >= File->End)
		{
		    DWORD part;
			//
			//      
			//     
			//
			File->Ptr = File->End = &File->Data[0];
			if (File->Handle == 0)
			{
				part = 0;
			}
			else
			{
				part = read(File->Handle, File->Ptr, File->Size);
			}
			if (part == 0)
			{
				//
				//   ,   
				// -  
				//
				if (len != 0)
				{
					*Data++ = 0;
					return len;
				}
				//
				//  ,   
				//
				return -1;
			}
			//
			// ,      
			//
			File->End += part;
		}
		//
		//      
		//
		sym = *File->Ptr++;
		//
		//    LF,  CR 
		//
		if (sym == 13) continue;
		if (sym == 10)
		{
			*Data++ = 0;
			return len;
		}
		*Data++ = sym;
		len++;
	}
	while(len < (FL_LINSIZE-1));
	//
	//     
	//
    ERR_ShowError(ERR_FATAL"Line %d in input source file is too long\n\r", nline);
    return -1;
}

//
//       
//      
//
DWORD FL_WriteArray(PFHANDLE File, PBYTE Data, DWORD Count)
{
	DWORD Write = 0;		//   
	DWORD Part;

	if (Count == 0) return 0;
	while(Write < Count)
	{
		if (File->Ptr >= File->End)
		{
			//
			//    ,   
			//       
			//
			File->Ptr = &File->Data[0];
			Part = write(File->Handle, File->Ptr, File->Size);
			if (Part != File->Size)
			{
				//
				//  - 
				//
				break;
			}
		}

		if ((DWORD)(File->End - File->Ptr) >= (Count - Write))
		{
			//
			//        
			//     ,   
			//      
			//
			memcpy(File->Ptr, Data + Write, Count - Write);
			File->Ptr += Count - Write;
			Write = Count;
			break;
		}

		//
		//      
		//
		memcpy(File->Ptr, Data + Write, File->End - File->Ptr);
		Write += (DWORD)(File->End - File->Ptr);
		File->Ptr = File->End;
	}
	
	//
	// ,    
	//
	if (Write == Count)
		return FL_ERR_SUCCESS;
	else
		return FL_ERR_WRITE;
}

//
//        
//    FL_LINSIZE    . 
//    CR/LF.
// 
//  < 0 -    
//			  >=0 -  
//
int FL_WriteLine(PFHANDLE File, PBYTE Data)
{
	int len;

	len = strlen(Data);
	Data[len+0] = 13;
	Data[len+1] = 10;

    if(FL_WriteArray(File, Data, len+2))
    {
        ERR_ShowError(ERR_FATAL"Output file write error\n\r");
        return -1;
    }
    return 0;
}

//
//       ,  
//      
//
DWORD FL_Flush(PFHANDLE File)
{
	int Result;

	if (!(File->Flags & FLFLG_ForWrite)) 
	{
		//
		//     ,  
		//
		return FL_ERR_SUCCESS;
	}

	if (File->Ptr != &File->Data[0])
	{
		Result = write(File->Handle, &File->Data[0], File->Ptr - &File->Data[0]);
		if (Result != File->Ptr - &File->Data[0])
		{
			ERR_ShowError(ERR_INFO"Write file error while flushing data\n\r");
			return FL_ERR_WRITE;
		}
		File->Ptr = &File->Data[0];
	}
	return FL_ERR_SUCCESS;
}

//
//    ,    
//  ,       ,
//   ,   
//
void FL_Close(PFHANDLE File)
{
	if (File->Handle != 0)
	{
		if (File->Flags & FLFLG_ForWrite)
		{
			FL_Flush(File);
		}
		close(File->Handle);
	}
	free(File);
}
